package model.attivita.atomiche;

import model.dominio.eventi.Start;
import model._gestioneeventi.EsecuzioneEnvironment;
import model._gestioneeventi.Environment;
import model.dominio.Ciclista;
import model.dominio.EccezioneMoltMinMax;
import model.dominio.Gara;
import model.dominio.TipoLinkPartecipa;
import model._framework.Task;
import java.util.*;



public class AvviaGara implements Task {
  private boolean eseguita = false;
  private Gara gara;

  public AvviaGara(Gara gara) {
    this.gara = gara;
  }

  public synchronized void esegui() {
    if (eseguita == true)
      return;
    eseguita = true;
    Iterator<TipoLinkPartecipa> it = null;
    try {
      it = gara.getLinkPartecipa().iterator();
    } catch (EccezioneMoltMinMax eccezione) {
      eccezione.printStackTrace();
      System.exit(1);
    }

    while (it.hasNext()) {
      Ciclista ciclista = it.next().getCiclista();
      EsecuzioneEnvironment.addListener(ciclista);
      Environment.aggiungiEvento(new Start(null, ciclista));// Va bene anche se
                                                            // in boradcast
    }

    EsecuzioneEnvironment.attivaListener();
  }

  public synchronized boolean estEseguita() {
    return eseguita;
  }

}
