package model.attivita.atomiche;

import model.dominio.Ciclista;
import model.dominio.EccezioneMoltMinMax;
import model.dominio.Gara;
import model.dominio.TipoLinkPartecipa;
import model._framework.Task;
import java.util.*;


public class TestFineGara implements Task {
  private boolean eseguita = false;
  private Gara gara;
  private boolean inCorso = false;

  public TestFineGara(Gara gara) {
    this.gara = gara;
  }

  public synchronized void esegui() {
    if (eseguita == true)
      return;
    eseguita = true;

    Set<TipoLinkPartecipa> partecipanti = null;
    try {
      partecipanti = gara.getLinkPartecipa();
    } catch (EccezioneMoltMinMax eccezione) {
      eccezione.printStackTrace();
      System.exit(1);
    }

    Iterator<TipoLinkPartecipa> it = partecipanti.iterator();
    while (it.hasNext() && !inCorso) {
      if (it.next().getCiclista().getStato() != Ciclista.Stato.FINITO) {
        inCorso = true;
      }
      // se non entra mai nell'if() risultato rimane false
    }
  }

  public synchronized boolean estEseguita() {
    return eseguita;
  }

  public synchronized boolean getRisultato() {
    return inCorso;
  }
}
